'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ListItemGroup = exports.ListItem = exports.List = exports.LIST = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _withTheme = require('../../utils/withTheme');

var _pure = require('../../utils/pure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LIST = exports.LIST = Symbol('List');
var CONTEXT_LEVEL_KEY = '__LIST_CONTEXT_LEVEL_KEY__';
var CONTEXT_TYPES = _defineProperty({}, CONTEXT_LEVEL_KEY, function () {});

var RawList = function (_React$Component) {
    _inherits(RawList, _React$Component);

    function RawList() {
        _classCallCheck(this, RawList);

        return _possibleConstructorReturn(this, (RawList.__proto__ || Object.getPrototypeOf(RawList)).apply(this, arguments));
    }

    _createClass(RawList, [{
        key: 'render',
        value: function render() {
            var level = this.context[CONTEXT_LEVEL_KEY] || 0;
            var _props = this.props,
                theme = _props.theme,
                children = _props.children;

            var className = (0, _classnames3.default)(theme.container, theme['container_level_' + level]);
            return React.createElement("ul", { className: className }, children);
        }
    }]);

    return RawList;
}(React.Component);

RawList.contextTypes = CONTEXT_TYPES;
var List = exports.List = (0, _withTheme.withTheme)(LIST)(RawList);
var RawListItem = function (_React$Component2) {
    _inherits(RawListItem, _React$Component2);

    function RawListItem() {
        _classCallCheck(this, RawListItem);

        return _possibleConstructorReturn(this, (RawListItem.__proto__ || Object.getPrototypeOf(RawListItem)).apply(this, arguments));
    }

    _createClass(RawListItem, [{
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                theme = _props2.theme,
                onClick = _props2.onClick,
                children = _props2.children;

            var level = this.context[CONTEXT_LEVEL_KEY] || 0;
            var className = (0, _classnames3.default)(theme.item, theme['item_level_' + level]);
            return React.createElement("li", { className: className, onClick: onClick }, children);
        }
    }]);

    return RawListItem;
}(React.Component);
RawListItem.contextTypes = CONTEXT_TYPES;
RawListItem = tslib_1.__decorate([_pure.PURE], RawListItem);
var ListItem = exports.ListItem = (0, _withTheme.withTheme)(LIST)(RawListItem);

var RawListItemGroup = function (_React$Component3) {
    _inherits(RawListItemGroup, _React$Component3);

    function RawListItemGroup() {
        _classCallCheck(this, RawListItemGroup);

        return _possibleConstructorReturn(this, (RawListItemGroup.__proto__ || Object.getPrototypeOf(RawListItemGroup)).apply(this, arguments));
    }

    _createClass(RawListItemGroup, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return _defineProperty({}, CONTEXT_LEVEL_KEY, (this.context[CONTEXT_LEVEL_KEY] || 0) + 1);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                theme = _props3.theme,
                isCollapsed = _props3.isCollapsed,
                children = _props3.children,
                header = _props3.header,
                onClick = _props3.onClick;

            var level = this.context[CONTEXT_LEVEL_KEY] || 0;
            var className = (0, _classnames3.default)(theme.itemGroup, theme['itemGroup_level_' + level], _defineProperty({}, theme.itemGroup_isCollapsed, isCollapsed));
            return React.createElement("li", { className: className }, React.createElement("span", { className: theme.itemGroup__header, onClick: onClick }, header), children);
        }
    }]);

    return RawListItemGroup;
}(React.Component);

RawListItemGroup.defaultProps = {
    isCollapsed: false
};
RawListItemGroup.contextTypes = CONTEXT_TYPES;
RawListItemGroup.childContextTypes = CONTEXT_TYPES;
var ListItemGroup = exports.ListItemGroup = (0, _withTheme.withTheme)(LIST)(RawListItemGroup);