'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.HorizontalScrollbar = exports.RawHorizontalScrollbar = exports.HORIZONTAL_SCROLLBAR = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _Scrollbar2 = require('./Scrollbar');

var _Scrollable = require('../Scrollable/Scrollable.const');

var _pure = require('../../utils/pure');

var _withTheme = require('../../utils/withTheme');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HORIZONTAL_SCROLLBAR = exports.HORIZONTAL_SCROLLBAR = Symbol('HorizontalScrollbar');
var RawHorizontalScrollbar = function (_Scrollbar) {
    _inherits(RawHorizontalScrollbar, _Scrollbar);

    function RawHorizontalScrollbar() {
        _classCallCheck(this, RawHorizontalScrollbar);

        var _this = _possibleConstructorReturn(this, (RawHorizontalScrollbar.__proto__ || Object.getPrototypeOf(RawHorizontalScrollbar)).apply(this, arguments));

        _this._scrollTo = function (position) {
            if (_this._container) {
                _this._container.scrollLeft = position;
            }
        };
        ////////////////////////
        // DOM EVENT HANDLERS //
        ////////////////////////
        /**
         * @param {WheelEvent} event
         * @protected
         */
        _this.onTrackMouseWheel = function (event) {
            if (_this._container) {
                _this._container.scrollLeft += event.deltaX * 10 || event['detail'] * 10 || event['wheelDelta'] * -1;
            }
        };
        /**
         * @param {MouseEvent} event
         * @protected
         */
        _this.onTrackClick = function (event) {
            if (_this._track && _this._container) {
                var trackPosition = _this._track.getBoundingClientRect().left + window.pageXOffset - document.documentElement.clientLeft;
                _this._container.scrollLeft = Math.floor((event.clientX - trackPosition) / _this._ratio.position);
            }
        };
        /**
         * @param {MouseEvent} event
         * @protected
         */
        _this.onBarDragStart = function (event) {
            _this._previousDragCoordinate = event.clientX;
        };
        /**
         * @param {MouseEvent} event
         * @protected
         */
        _this.onBarDrag = function (event) {
            if (_this._container) {
                var delta = _this._previousDragCoordinate - event.clientX;
                _this._previousDragCoordinate = event.clientX;
                _this._container.scrollLeft -= delta / _this._ratio.position;
            }
        };
        return _this;
    }
    /**
     * @returns {Number}
     * @protected
     */


    _createClass(RawHorizontalScrollbar, [{
        key: '_getMinBarSize',
        value: function _getMinBarSize() {
            return parseFloat(window.getComputedStyle(this._bar).getPropertyValue('min-width'));
        }
        /**
         * Hide native scroll
         * @private
         */

    }, {
        key: '_hideNativeScrollContainer',
        value: function _hideNativeScrollContainer() {
            var container = this.props.container;
            var height = this.context.size.height;

            container.style.marginBottom = '-' + height + 'px';
            container.style.height = 'calc(100% + ' + height + 'px)';
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            _get(RawHorizontalScrollbar.prototype.__proto__ || Object.getPrototypeOf(RawHorizontalScrollbar.prototype), 'componentDidMount', this).call(this);
            this._minBarSize = this._getMinBarSize();
            this._hideNativeScrollContainer();
            this._update();
            if (this.props.scrollLeft) {
                this._scrollTo(this.props.scrollLeft);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            if (this.props.scrollLeft !== newProps.scrollLeft) {
                if (newProps.scrollLeft) {
                    this._scrollTo(newProps.scrollLeft);
                }
            }
        }
    }, {
        key: '_update',
        value: function _update() {
            this._toggle();
            this._ratio = this._getRatio();
            this._updateBar();
        }
    }, {
        key: '_toggle',
        value: function _toggle() {
            var container = this.props.container;

            var bounds = container.getBoundingClientRect();
            var visibleWidth = Math.round(bounds.width);
            var scrollWidth = container.scrollWidth;
            var isVisible = scrollWidth > visibleWidth;
            if (isVisible !== this.state.isVisible) {
                this.setState({
                    isVisible: isVisible
                });
                var emitter = this.context[_Scrollable.SCROLLABLE_CONTEXT_EMITTER];
                emitter.emit(_Scrollable.EVENT_SCROLABLE.SCROLLBAR_UPDATE, _Scrollbar2.SCROLLBAR_TYPE.HORIZONTAL, isVisible);
            }
        }
    }, {
        key: '_updateBar',
        value: function _updateBar() {
            var container = this.props.container;

            var visibleWidth = container.clientWidth;
            var barWidth = Math.ceil(visibleWidth * this._ratio.size);
            this._bar.style.width = barWidth + 'px';
            //position
            var scrollLeft = container.scrollLeft;
            var barPositionLeft = Math.floor(scrollLeft * this._ratio.position);
            this._bar.style.left = barPositionLeft + 'px';
        }
    }, {
        key: '_getRatio',
        value: function _getRatio() {
            if (this._container && this._track) {
                var _container = this._container,
                    scrollSize = _container.scrollWidth,
                    containerSize = _container.clientWidth;
                var trackSize = this._track.offsetWidth;

                var sizeRatio = trackSize / scrollSize;
                var possibleBarSize = containerSize * sizeRatio;
                var barSize = possibleBarSize < this._minBarSize ? this._minBarSize : possibleBarSize;
                var hiddenContentAreaSize = scrollSize - containerSize;
                var hiddenTrackAreaSize = trackSize - barSize;
                var positionRatio = hiddenTrackAreaSize / hiddenContentAreaSize;
                return {
                    size: sizeRatio,
                    position: positionRatio
                };
            }
            return {
                size: 0,
                position: 0
            };
        }
    }]);

    return RawHorizontalScrollbar;
}(_Scrollbar2.Scrollbar);
exports.RawHorizontalScrollbar = RawHorizontalScrollbar = tslib_1.__decorate([_pure.PURE], RawHorizontalScrollbar);
exports.RawHorizontalScrollbar = RawHorizontalScrollbar;
var HorizontalScrollbar = exports.HorizontalScrollbar = (0, _withTheme.withTheme)(HORIZONTAL_SCROLLBAR)(RawHorizontalScrollbar);